var USER_TYPE = 2,
    PREPARE_TYPE = 3,
    MASTER_TYPE = 4,
    VIP_MASTER_TYPE = 5,
    PROMPTER_TYPE = 6;
var shareurl = "http://www.52hsfdj.com/";
var seversurl = shareurl + "haoshifu/";
var imgDomainName = "image.52hsfdj.com";
window.AJAX = {
    /**
     * POST请求
     * @param {String} url 接口地址
     * @param {JSON} data 发送参数
     * @param {Object} succCall 成功回调方法
     * @param {Object} errCall 失败回调方法
     * @param {String} method 请求方式，可选POST、PUT，默认为POST
     */
    post: function(url, data, succCall, errCall, method) {
        method = method ? method : "POST";
        var token = plus.storage.getItem("user_token");
        var secretKey = plus.storage.getItem("user_secretKey");
        if(token && secretKey) {
            if(url.indexOf("?") > 0) {
                url += "&token=" + token;
            } else {
                url += "?token=" + token;
            }
            var digest = getDigest(secretKey, url);
            url += "&digest=" + digest;
        }
        url = seversurl + url;
        //console.log(url);
        //console.log(JSON.stringify(data));
        //var xhr = new plus.net.XMLHttpRequest();
        //超时判断(10s) begin
        var timeout = false;
        var timer = setTimeout(function() {
            timeout = true;
            xhr.abort();
        }, 10000);
        //超时判断 end
        var xhr = new XMLHttpRequest();
        xhr.onreadystatechange = function() {
            if(timeout) {
                var json;
                json = {
                    status: false,
                    msg: "网络连接超时，请稍后重试",
                }
                errCall && errCall(json);
            };
            clearTimeout(timer);
            if(xhr.readyState == 4) {
                if(xhr.status == 200) {
                    if(succCall) {
                        var json;
                        try {
                            var json = eval("(" + xhr.responseText + ")");
                            json['rawdata'] = xhr.responseText;
                        } catch(e) {
                            //TODO handle the exception
                            json = {
                                status: false,
                                msg: '返回数据错误',
                                err: xhr.responseText
                            }
                        }
                        if(json.status == 2) {
                            mui.alert("登陆超时，请重新登陆", function() {
                                clearUserInfo();
                            });
                        } else {
                            succCall(json);
                        }
                    }
                } else {
                    if(errCall) {
                        errCall(xhr.readyState);
                    }
                }
            }
        }
        xhr.open(method, url, true);
        xhr.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
        xhr.send(JSON.stringify(data));
    },
    /**
     * GET请求
     * @param {String} url 接口地址
     * @param {Object} succCall 成功回调方法
     * @param {Object} errCall 失败回调方法
     * @param {String} method 请求方式，可选GET、DELETE，默认为GET
     */
    get: function(url, succCall, errCall, method) {
        method = method ? method : "GET";
        var token = plus.storage.getItem("user_token");
        var secretKey = plus.storage.getItem("user_secretKey");
        if(token && secretKey) {
            if(url.indexOf("?") > 0) {
                url += "&token=" + token;
            } else {
                url += "?token=" + token;
            }
            var digest = getDigest(secretKey, url);
            url += "&digest=" + digest;
        }
        url = seversurl + url;
        //console.log(url);
        var xhr = new plus.net.XMLHttpRequest();
        var xhr = new XMLHttpRequest();
        //超时判断(10s) begin
        var timeout = false;
        var timer = setTimeout(function() {
            timeout = true;
            xhr.abort();
        }, 10000);
        //超时判断 end
        xhr.onreadystatechange = function() {
            if(timeout) {
                var json;
                json = {
                    status: false,
                    msg: "网络连接超时，请稍后重试",
                }
                errCall && errCall(json);
            };
            clearTimeout(timer);
            if(xhr.readyState == 4) {
                if(xhr.status == 200) {
                    if(succCall) {
                        var json;
                        try {
                            var json = eval("(" + xhr.responseText + ")");
                            json['rawdata'] = xhr.responseText;
                        } catch(e) {
                            //TODO handle the exception
                            json = {
                                status: false,
                                msg: '返回数据错误',
                                err: xhr.responseText
                            }
                        }
                        if(json.status == 2) {
                            mui.alert("登陆超时，请重新登陆", function() {
                                clearUserInfo();
                            });
                        } else {
                            succCall(json);
                        }
                    }
                } else {
                    if(errCall) {
                        console.log("请求失败url：");
                        console.log(url);
                        errCall(xhr.response);
                    }
                }
            }
        }
        xhr.open(method, url);
        xhr.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
        xhr.send();
    }
};
/**
 * 删除节点
 * @param {Object} _element DOM元素
 */
function removeElement(_element) {
    if(_element) {
        var _parentElement = _element.parentNode;
        if(_parentElement) {
            _parentElement.removeChild(_element);
        }
    }
}

function getDigest(secretKey, url) {
    var params = GetRequestForDigest(url);
    var val = "";
    for(var i in params) {
        val += params[i];
    }
    return hex_hmac_sha256(secretKey, val);
}
/**
 * 获取URL传递的参数
 * @return JSON
 */
function GetRequestForDigest(url) {
    var arr = [];
    var params = new Object();
    var theRequest = new Object();
    if(url.indexOf("?") != -1) {
        var str = url.substr(url.indexOf("?") + 1);
        strs = str.split("&");
        for(var i = 0; i < strs.length; i++) {
            arr.push(strs[i].split("=")[0]);
            theRequest[strs[i].split("=")[0]] = unescape(strs[i].split("=")[1]);
        }
    }
    arr.sort();
    for(var i in arr) {
        params[arr[i]] = theRequest[arr[i]];
    }
    return params;
}
/**
 * 注销登录
 */
function logout() {
    var userId = plus.storage.getItem("user_id");
    if(userId) {
        plus.nativeUI.showWaiting();
        AJAX.get("logout", function(xhr) {
            plus.nativeUI.closeWaiting();
            if(xhr.status == 1) {
                clearUserInfo();
            } else {
                mui.alert(xhr.msg ? xhr.msg : "退出失败，请重试");
            }
        }, function(xhr) {
            plus.nativeUI.closeWaiting();
            mui.alert("网络连接失败，请重试");
        });
    } else {
        clearUserInfo();
    }
}
/**
 * 清除用户本地数据，城市除外
 */
function clearUserInfo() {
    var lauchFlag = plus.storage.getItem("lauchFlag");
    var city = plus.storage.getItem("user_city");
    plus.storage.clear();
    plus.storage.setItem("user_city", city);
    plus.storage.setItem("lauchFlag", lauchFlag);
    var all = plus.webview.all();
    var index = plus.runtime.appid;
    for(var i in all) {
        if(all[i].id != index) {
            all[i].close();
        } else {
            mui.fire(all[i], 'gopersonal');
            plus.storage.setItem("user_switch_gps", "close");
        }
    }
}
/**
 * 替换图片链接
 * @param {Object} url 原链接
 */
function replaceImgUrl(url) {
    var newUrl = "";
    newUrl = url.replace("haoshifu.oss-cn-beijing.aliyuncs.com", imgDomainName);
    newUrl += "@0o_0l_80w_100q.src";
    return newUrl;
}
/**
 * 清除输入表情符号
 * @param {Object} str
 */
function emoji2Str(str) {
    console.log(encodeURIComponent(str));
    return unescape(escape(str).replace(/\%uD.{3}/g, ''));
}
/**
 * 验证手机号码的有效性
 * 验证130-139,150-159，170-179,180-189号码段的手机号码
 * @param {String} tel 手机号
 */
function telCheck(tel) {
    var myreg = /^(((13[0-9]{1})|(15[0-9]{1})|(17[0-9]{1})|(18[0-9]{1}))+\d{8})$/;
    if(myreg.test(tel)) {
        return true;
    } else {
        return false;
    }
}
//遍历所有本地存储数据
function enumValueByIndex() {
    var keyNames = [];
    var values = [];
    var numKeys = plus.storage.getLength();
    for(var i = 0; i < numKeys; i++) {
        keyNames[i] = plus.storage.key(i);
        values[i] = plus.storage.getItem(keyNames[i]);
        //console.log(keyNames[i] + ":" + values[i]);
    }
}

function postGPSLog(GPSErrorLog, msg) {
    var osversion, devicevendor, appversion;
    osversion = plus.os.name + plus.os.version;
    devicevendor = plus.device.vendor + plus.device.model;
    plus.runtime.getProperty(plus.runtime.appid, function(inf) {
        appversion = inf.version;
        var userId = "userId:" + plus.storage.getItem("user_id");
        var errorMeg = "系统版本: " + osversion + ";手机型号:" + devicevendor + ";app版本:" + appversion + ";错误信息:" + msg + ";用户ID:" + userId;
        var data = {
            errorType: 1,
            module: GPSErrorLog,
            operation: 1,
            errorMeg: errorMeg
        }
        var url = "sysErrorLog/save";
        AJAX.post(url, data, function(xhr) {
            if(xhr.status != 1) {
                mui.toast(xhr.msg);
                return false;
            } else {
                //mui.toast("发送成功");
            }
        }, function(xhr) {
            //mui.toast("连接网络失败，请稍后再试");
        });
    });
}
/**
 * 获取定位地址和GPS
 * @param {Object} succCall 定位成功回调
 * @param {Object} failCall 定位失败回调
 */
function getLocation(succCall, failCall) {
    var failed = false;
    plus.geolocation.getCurrentPosition(function(p) {
        var data = {};
        data["latitude"] = parseFloat(p.coords.latitude).toFixed(4);
        data["longitude"] = parseFloat(p.coords.longitude).toFixed(4);
        var url = "gps/getCity?lag=" + data["longitude"] + "&lat=" + data["latitude"];
        AJAX.get(url, function(xhr) {
            if(xhr.status == 1) {
                data["city"] = xhr.content.city;
                succCall && succCall(data);
            } else {
                postGPSLog("定位失败", xhr.msg);
                failCall();
            }
        }, function(xhr) {
            postGPSLog("定位失败", "网络请求失败");
            failCall();
        });
    }, function(error) {
        if(!failed) {
            failed = true;
            postGPSLog("定位失败", error.message + ";错误代码:" + error.code);
            failCall();
        }
    }, {
        geocode: false,
        timeout: 3000
    });
}

function getLocationByPlus(succCall, failCall) {
    plus.geolocation.getCurrentPosition(function(p) {
        if(!p.address.city) {
            postGPSLog("定位失败", "未获取到城市");
            mui.alert("定位失败，请打开GPS并检查保持网络通畅");
            failCall && failCall();
            return;
        }
        var data = {};
        data["latitude"] = parseFloat(p.coords.latitude).toFixed(4);
        data["longitude"] = parseFloat(p.coords.longitude).toFixed(4);
        data["city"] = p.address.city;
        succCall && succCall(data);
    }, function(e) {
        postGPSLog("定位失败", e.message);
        mui.alert("定位失败，请打开GPS并检查保持网络通畅");
        failCall && failCall();
        return;
    }, {
        provider: 'amap',
        timeout: 8000
    });
}
/**
 * 创建悬浮窗口
 * @param {Object} url 窗口路径
 * @param {Object} extras 扩展参数
 * @param {Object} styles 样式
 */
function openFloat(url, extras, styles) {
    extras = extras ? extras : {};
    styles = styles ? styles : {
        height: '350px',
        right: '0px',
        top: '44px'
    };
    mui.openWindow({
        id: url,
        url: url,
        extras: extras,
        styles: styles,
        show: {
            aniShow: "zoom-fade-out"
        }
    });
    plus.webview.currentWebview().setStyle({
        mask: 'rgba(0,0,0,0.5)'
    });
    plus.webview.currentWebview().addEventListener("maskClick", function() {
        plus.webview.currentWebview().setStyle({
            mask: "none"
        });
        plus.webview.getWebviewById(url).close();
    }, false);
}
/**
 * 上传文件
 * @param {Object} file 文件
 * @param {Boolean} zip = [true|false] 是否压缩 默认false
 * @param {Object} succCall 成功回调方法
 * @param {String} fileType = [icon|certification] 图片类型 
 */
function upload(file, zip, succCall, fileType) {
    var fileDir = "";
    if(!file) {
        plus.nativeUI.alert("没有添加上传文件！");
        return;
    }
    switch(fileType) {
        case "icon":
            fileDir = "icon/";
            break;
        case "certification":
            fileDir = "certification/";
            break;
    }
    var userId = plus.storage.getItem("user_id");
    if(userId) {
        fileDir += userId + "/";
    }
    plus.nativeUI.showWaiting();
    AJAX.get("ossKey", function(xhr) {
        if(xhr.status == 1) {
            var task = plus.uploader.createUpload(xhr.content.host, {
                    method: "POST",
                    priority: 100
                },
                function(t, status) { //上传完成
                    plus.nativeUI.closeWaiting();
                    if(status == 200 || status == 201) {
                        var xmlDoc;
                        try //Internet Explorer
                        {
                            xmlDoc = new ActiveXObject("Microsoft.XMLDOM");
                            xmlDoc.async = "false";
                            xmlDoc.loadXML(t.responseText);
                        } catch(e) {
                            try //Firefox, Mozilla, Opera, etc.
                            {
                                parser = new DOMParser();
                                xmlDoc = parser.parseFromString(t.responseText, "text/xml");
                            } catch(e) {
                                plus.nativeUI.alert(e.message);
                                return;
                            }
                        }
                        succCall(xmlDoc.getElementsByTagName("Location")[0].childNodes[0].nodeValue);
                    } else {
                        plus.nativeUI.alert(t.responseText);
                    }
                }
            );
            var suffix = file.path.substring(file.path.lastIndexOf("."));
            var dateTime = new Date().getTime();
            task.addData("key", xhr.content.dir + "/" + fileDir + dateTime + suffix);
            task.addData("OSSAccessKeyId", xhr.content.accessid.toString());
            task.addData("policy", xhr.content.policy.toString());
            task.addData("Signature", xhr.content.signature.toString());
            task.addData("callback", xhr.content.callback ? xhr.content.callback : "");
            task.addData("success_action_status", "201");
            // 状态切换
            task.addEventListener("statechanged", function(uploader, status) {
                if(task.state == 0) {
                    console.log("上传开始");
                }
            }, false);
            if(zip) {
                plus.zip.compressImage({
                        src: file.path,
                        dst: file.path,
                        overwrite: true,
                        width: "720px",
                        height: "720px"
                    },
                    function() {
                        task.addFile(file.path, {
                            key: file.name,
                            name: "file",
                            mime: "image/jpeg"
                        });
                        task.start();
                    },
                    function(error) {
                        task.addFile(file.path, {
                            key: file.name,
                            name: "file",
                            mime: "image/jpeg"
                        });
                        task.start();
                    });
            } else {
                task.addFile(file.path, {
                    key: file.name,
                    name: "file",
                    mime: "image/jpeg"
                });
                task.start();
            }
        } else {
            plus.nativeUI.showWaiting();
            plus.nativeUI.toast("网络连接失败，请重试");
        }
    }, function(xhr) {
        plus.nativeUI.showWaiting();
        plus.nativeUI.toast("网络连接失败，请重试");
    });
}
/*
 * A JavaScript implementation of the Secure Hash Algorithm, SHA-256, as defined
 * in FIPS 180-2
 * Version 2.2 Copyright Angel Marin, Paul Johnston 2000 - 2009.
 * Other contributors: Greg Holt, Andrew Kepert, Ydnar, Lostinet
 * Distributed under the BSD License
 * See http://pajhome.org.uk/crypt/md5 for details.
 * Also http://anmar.eu.org/projects/jssha2/
 */

/*
 * Configurable variables. You may need to tweak these to be compatible with
 * the server-side, but the defaults work in most cases.
 */
var hexcase = 0; /* hex output format. 0 - lowercase; 1 - uppercase        */
var b64pad = ""; /* base-64 pad character. "=" for strict RFC compliance   */

/*
 * These are the functions you'll usually want to call
 * They take string arguments and return either hex or base-64 encoded strings
 */
function hex_sha256(s) {
    return rstr2hex(rstr_sha256(str2rstr_utf8(s)));
}

function b64_sha256(s) {
    return rstr2b64(rstr_sha256(str2rstr_utf8(s)));
}

function any_sha256(s, e) {
    return rstr2any(rstr_sha256(str2rstr_utf8(s)), e);
}

function hex_hmac_sha256(k, d) {
    return rstr2hex(rstr_hmac_sha256(str2rstr_utf8(k), str2rstr_utf8(d)));
}

function b64_hmac_sha256(k, d) {
    return rstr2b64(rstr_hmac_sha256(str2rstr_utf8(k), str2rstr_utf8(d)));
}

function any_hmac_sha256(k, d, e) {
    return rstr2any(rstr_hmac_sha256(str2rstr_utf8(k), str2rstr_utf8(d)), e);
}

/*
 * Perform a simple self-test to see if the VM is working
 */
function sha256_vm_test() {
    return hex_sha256("abc").toLowerCase() ==
        "ba7816bf8f01cfea414140de5dae2223b00361a396177a9cb410ff61f20015ad";
}

/*
 * Calculate the sha256 of a raw string
 */
function rstr_sha256(s) {
    return binb2rstr(binb_sha256(rstr2binb(s), s.length * 8));
}

/*
 * Calculate the HMAC-sha256 of a key and some data (raw strings)
 */
function rstr_hmac_sha256(key, data) {
    var bkey = rstr2binb(key);
    if(bkey.length > 16) bkey = binb_sha256(bkey, key.length * 8);

    var ipad = Array(16),
        opad = Array(16);
    for(var i = 0; i < 16; i++) {
        ipad[i] = bkey[i] ^ 0x36363636;
        opad[i] = bkey[i] ^ 0x5C5C5C5C;
    }

    var hash = binb_sha256(ipad.concat(rstr2binb(data)), 512 + data.length * 8);
    return binb2rstr(binb_sha256(opad.concat(hash), 512 + 256));
}

/*
 * Convert a raw string to a hex string
 */
function rstr2hex(input) {
    try {
        hexcase
    } catch(e) {
        hexcase = 0;
    }
    var hex_tab = hexcase ? "0123456789ABCDEF" : "0123456789abcdef";
    var output = "";
    var x;
    for(var i = 0; i < input.length; i++) {
        x = input.charCodeAt(i);
        output += hex_tab.charAt((x >>> 4) & 0x0F) + hex_tab.charAt(x & 0x0F);
    }
    return output;
}

/*
 * Convert a raw string to a base-64 string
 */
function rstr2b64(input) {
    try {
        b64pad
    } catch(e) {
        b64pad = '';
    }
    var tab = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
    var output = "";
    var len = input.length;
    for(var i = 0; i < len; i += 3) {
        var triplet = (input.charCodeAt(i) << 16) | (i + 1 < len ? input.charCodeAt(i + 1) << 8 : 0) | (i + 2 < len ? input.charCodeAt(i + 2) : 0);
        for(var j = 0; j < 4; j++) {
            if(i * 8 + j * 6 > input.length * 8) output += b64pad;
            else output += tab.charAt((triplet >>> 6 * (3 - j)) & 0x3F);
        }
    }
    return output;
}

/*
 * Convert a raw string to an arbitrary string encoding
 */
function rstr2any(input, encoding) {
    var divisor = encoding.length;
    var remainders = Array();
    var i, q, x, quotient;

    /* Convert to an array of 16-bit big-endian values, forming the dividend */
    var dividend = Array(Math.ceil(input.length / 2));
    for(i = 0; i < dividend.length; i++) {
        dividend[i] = (input.charCodeAt(i * 2) << 8) | input.charCodeAt(i * 2 + 1);
    }

    /*
     * Repeatedly perform a long division. The binary array forms the dividend,
     * the length of the encoding is the divisor. Once computed, the quotient
     * forms the dividend for the next step. We stop when the dividend is zero.
     * All remainders are stored for later use.
     */
    while(dividend.length > 0) {
        quotient = Array();
        x = 0;
        for(i = 0; i < dividend.length; i++) {
            x = (x << 16) + dividend[i];
            q = Math.floor(x / divisor);
            x -= q * divisor;
            if(quotient.length > 0 || q > 0)
                quotient[quotient.length] = q;
        }
        remainders[remainders.length] = x;
        dividend = quotient;
    }

    /* Convert the remainders to the output string */
    var output = "";
    for(i = remainders.length - 1; i >= 0; i--)
        output += encoding.charAt(remainders[i]);

    /* Append leading zero equivalents */
    var full_length = Math.ceil(input.length * 8 /
        (Math.log(encoding.length) / Math.log(2)))
    for(i = output.length; i < full_length; i++)
        output = encoding[0] + output;

    return output;
}

/*
 * Encode a string as utf-8.
 * For efficiency, this assumes the input is valid utf-16.
 */
function str2rstr_utf8(input) {
    var output = "";
    var i = -1;
    var x, y;

    while(++i < input.length) {
        /* Decode utf-16 surrogate pairs */
        x = input.charCodeAt(i);
        y = i + 1 < input.length ? input.charCodeAt(i + 1) : 0;
        if(0xD800 <= x && x <= 0xDBFF && 0xDC00 <= y && y <= 0xDFFF) {
            x = 0x10000 + ((x & 0x03FF) << 10) + (y & 0x03FF);
            i++;
        }

        /* Encode output as utf-8 */
        if(x <= 0x7F)
            output += String.fromCharCode(x);
        else if(x <= 0x7FF)
            output += String.fromCharCode(0xC0 | ((x >>> 6) & 0x1F),
                0x80 | (x & 0x3F));
        else if(x <= 0xFFFF)
            output += String.fromCharCode(0xE0 | ((x >>> 12) & 0x0F),
                0x80 | ((x >>> 6) & 0x3F),
                0x80 | (x & 0x3F));
        else if(x <= 0x1FFFFF)
            output += String.fromCharCode(0xF0 | ((x >>> 18) & 0x07),
                0x80 | ((x >>> 12) & 0x3F),
                0x80 | ((x >>> 6) & 0x3F),
                0x80 | (x & 0x3F));
    }
    return output;
}

/*
 * Encode a string as utf-16
 */
function str2rstr_utf16le(input) {
    var output = "";
    for(var i = 0; i < input.length; i++)
        output += String.fromCharCode(input.charCodeAt(i) & 0xFF,
            (input.charCodeAt(i) >>> 8) & 0xFF);
    return output;
}

function str2rstr_utf16be(input) {
    var output = "";
    for(var i = 0; i < input.length; i++)
        output += String.fromCharCode((input.charCodeAt(i) >>> 8) & 0xFF,
            input.charCodeAt(i) & 0xFF);
    return output;
}

/*
 * Convert a raw string to an array of big-endian words
 * Characters >255 have their high-byte silently ignored.
 */
function rstr2binb(input) {
    var output = Array(input.length >> 2);
    for(var i = 0; i < output.length; i++)
        output[i] = 0;
    for(var i = 0; i < input.length * 8; i += 8)
        output[i >> 5] |= (input.charCodeAt(i / 8) & 0xFF) << (24 - i % 32);
    return output;
}

/*
 * Convert an array of big-endian words to a string
 */
function binb2rstr(input) {
    var output = "";
    for(var i = 0; i < input.length * 32; i += 8)
        output += String.fromCharCode((input[i >> 5] >>> (24 - i % 32)) & 0xFF);
    return output;
}

/*
 * Main sha256 function, with its support functions
 */
function sha256_S(X, n) {
    return(X >>> n) | (X << (32 - n));
}

function sha256_R(X, n) {
    return(X >>> n);
}

function sha256_Ch(x, y, z) {
    return((x & y) ^ ((~x) & z));
}

function sha256_Maj(x, y, z) {
    return((x & y) ^ (x & z) ^ (y & z));
}

function sha256_Sigma0256(x) {
    return(sha256_S(x, 2) ^ sha256_S(x, 13) ^ sha256_S(x, 22));
}

function sha256_Sigma1256(x) {
    return(sha256_S(x, 6) ^ sha256_S(x, 11) ^ sha256_S(x, 25));
}

function sha256_Gamma0256(x) {
    return(sha256_S(x, 7) ^ sha256_S(x, 18) ^ sha256_R(x, 3));
}

function sha256_Gamma1256(x) {
    return(sha256_S(x, 17) ^ sha256_S(x, 19) ^ sha256_R(x, 10));
}

function sha256_Sigma0512(x) {
    return(sha256_S(x, 28) ^ sha256_S(x, 34) ^ sha256_S(x, 39));
}

function sha256_Sigma1512(x) {
    return(sha256_S(x, 14) ^ sha256_S(x, 18) ^ sha256_S(x, 41));
}

function sha256_Gamma0512(x) {
    return(sha256_S(x, 1) ^ sha256_S(x, 8) ^ sha256_R(x, 7));
}

function sha256_Gamma1512(x) {
    return(sha256_S(x, 19) ^ sha256_S(x, 61) ^ sha256_R(x, 6));
}

var sha256_K = new Array(
    1116352408, 1899447441, -1245643825, -373957723, 961987163, 1508970993, -1841331548, -1424204075, -670586216, 310598401, 607225278, 1426881987,
    1925078388, -2132889090, -1680079193, -1046744716, -459576895, -272742522,
    264347078, 604807628, 770255983, 1249150122, 1555081692, 1996064986, -1740746414, -1473132947, -1341970488, -1084653625, -958395405, -710438585,
    113926993, 338241895, 666307205, 773529912, 1294757372, 1396182291,
    1695183700, 1986661051, -2117940946, -1838011259, -1564481375, -1474664885, -1035236496, -949202525, -778901479, -694614492, -200395387, 275423344,
    430227734, 506948616, 659060556, 883997877, 958139571, 1322822218,
    1537002063, 1747873779, 1955562222, 2024104815, -2067236844, -1933114872, -1866530822, -1538233109, -1090935817, -965641998
);

function binb_sha256(m, l) {
    var HASH = new Array(1779033703, -1150833019, 1013904242, -1521486534,
        1359893119, -1694144372, 528734635, 1541459225);
    var W = new Array(64);
    var a, b, c, d, e, f, g, h;
    var i, j, T1, T2;

    /* append padding */
    m[l >> 5] |= 0x80 << (24 - l % 32);
    m[((l + 64 >> 9) << 4) + 15] = l;

    for(i = 0; i < m.length; i += 16) {
        a = HASH[0];
        b = HASH[1];
        c = HASH[2];
        d = HASH[3];
        e = HASH[4];
        f = HASH[5];
        g = HASH[6];
        h = HASH[7];

        for(j = 0; j < 64; j++) {
            if(j < 16) W[j] = m[j + i];
            else W[j] = safe_add(safe_add(safe_add(sha256_Gamma1256(W[j - 2]), W[j - 7]),
                sha256_Gamma0256(W[j - 15])), W[j - 16]);

            T1 = safe_add(safe_add(safe_add(safe_add(h, sha256_Sigma1256(e)), sha256_Ch(e, f, g)),
                sha256_K[j]), W[j]);
            T2 = safe_add(sha256_Sigma0256(a), sha256_Maj(a, b, c));
            h = g;
            g = f;
            f = e;
            e = safe_add(d, T1);
            d = c;
            c = b;
            b = a;
            a = safe_add(T1, T2);
        }

        HASH[0] = safe_add(a, HASH[0]);
        HASH[1] = safe_add(b, HASH[1]);
        HASH[2] = safe_add(c, HASH[2]);
        HASH[3] = safe_add(d, HASH[3]);
        HASH[4] = safe_add(e, HASH[4]);
        HASH[5] = safe_add(f, HASH[5]);
        HASH[6] = safe_add(g, HASH[6]);
        HASH[7] = safe_add(h, HASH[7]);
    }
    return HASH;
}

function safe_add(x, y) {
    var lsw = (x & 0xFFFF) + (y & 0xFFFF);
    var msw = (x >> 16) + (y >> 16) + (lsw >> 16);
    return(msw << 16) | (lsw & 0xFFFF);
}