document.getElementById("login").addEventListener("tap", function() {
    login();
});

function showTip() {
    document.getElementById("tip").style.display = "";
}

function hideTip() {
    document.getElementById("tip").style.display = "none";
}
document.getElementById("register").addEventListener("tap", function() {
    mui.openWindow({
        url: 'index/register_user.html',
        id: 'register_user.html',
    });
});
document.getElementById("forgetPassword").addEventListener("tap", function() {
    mui.openWindow({
        url: 'index/forget_password.html',
        id: 'forget_password.html'
    });
});
document.getElementById("autoLogin").addEventListener("toggle", function(event) {
    if(event.detail.isActive) {
        plus.storage.removeItem("user_auto_login");
    } else {
        plus.storage.setItem("user_auto_login", "false");
    }
})

function login() {
    var name = document.getElementById("account").value.trim();
    var pwd = document.getElementById("password").value;
    if(!name) {
        mui.alert("请输入帐号");
        return;
    }
    if(!pwd) {
        mui.alert("请输入密码");
        return;
    }
    var data = {
        name: name,
        pwd: pwd
    };
    plus.nativeUI.showWaiting("", {
        padlock: true
    });
    AJAX.post("login", data, function(xhr) {
        if(xhr.status == 1 && xhr.content.typeId) {
            //保存用户信息 begin
            plus.storage.setItem("user_id", xhr.content.id.toString());
            plus.storage.setItem("user_secretKey", xhr.content.secretKey.toString());
            plus.storage.setItem("user_token", xhr.content.token.toString());
            plus.storage.setItem("user_type", xhr.content.typeId.toString());
            //保存用户信息 end
            getUserInfo();
        } else {
            plus.nativeUI.closeWaiting();
            mui.toast(xhr.msg ? xhr.msg : "登录失败，请重试");
        }
    }, function(xhr) {
        plus.nativeUI.closeWaiting();
        mui.toast("连接网络失败，请稍后再试");
    });
}

//获取用户信息
function getUserInfo(noJump) {
    var userId = plus.storage.getItem("user_id"),
        typeId = plus.storage.getItem("user_type"),
        url;
    if(!userId) {
        return;
    }
    if(typeId < 3) {
        url = "user/get/" + userId;
    } else {
        url = "userWorker/get/" + userId;
    }
    AJAX.get(url, function(xhr) {
        plus.nativeUI.closeWaiting();
        if(xhr.status == 1) {
            !noJump && mui.toast("登陆成功");
            //清空账号和秘密输入框
            document.getElementById("account").value = "";
            document.getElementById("password").value = "";
            if(!xhr.content.userName) {
                xhr.content["userName"] = xhr.content.name;
            }
            plus.storage.setItem("user_type", xhr.content.typeId.toString());
            plus.storage.setItem("user_info", JSON.stringify(xhr.content));
            getData();
            document.getElementById("login-box").style.display = "none";
            document.getElementById("personal-box").style.display = "block";
            getGpsStatus();
        } else {
            logout();
            mui.alert(xhr.msg ? xhr.msg : "获取登陆信息失败，请重新登录");
        }
    }, function(xhr) {
        logout();
        plus.nativeUI.closeWaiting();
        mui.toast("网络连接失败，请重试");
    });
}
//获取GPS开关状态
function getGpsStatus() {
    var userId = plus.storage.getItem("user_id");
    if(!userId) {
        return;
    }
    var url = "setting/getUserSettings/" + userId;
    AJAX.get(url, function(xhr) {
        if(xhr.status) {
            if(xhr.content["switchGps"]) {
                plus.storage.setItem("user_switch_gps", "open");
                updateGPS();
            } else {
                updateGPS();
                plus.storage.setItem("user_switch_gps", "close");
            }
        }
    }, function(){
        updateGPS();
    });
}
document.addEventListener("refreshData", function() {
    getUserInfo(true);
});