//获取本地应用资源版本号
function version() {
    plus.runtime.getProperty(plus.runtime.appid, function(inf) {
        checkUpdate(inf.version);
    });
}
//检查版本更新
function checkUpdate(thisVersion) {
    var osName = "";
    switch(plus.os.name) {
        case "Android":
            osName = 100;
            break;
        case "iOS":
            osName = 200;
            break;
    }
    var url = "getNewVersion?version=" + thisVersion + "&osName=" + osName;
    AJAX.get(url, function(xhr) {
        if(xhr.status == 1) {
            checkUpdateSuccCall(xhr);
        } else {
            mui.alert(xhr.msg ? xhr.msg : "检查更新失败，请重试", function() {
                version();
            });
        }
    }, function(e) {
        mui.alert("网络链接失败，请重试", function() {
            version();
        });
    });
}
//检查更新成功
function checkUpdateSuccCall(xhr) {
    if(xhr.content && xhr.content.update) {
        if(xhr.content.updateType) {
            var msg = xhr.content.versionMsg ? xhr.content.versionMsg : "已发布新版本，请及时更新";
            mui.confirm(msg, "提示", ["稍后更新", "立即更新"], function(e) {
                if(e.index) {
                    installTypeCheck(xhr.content);
                } else {
                    getMaxType();
                }
            });
        } else {
            installTypeCheck(xhr.content);
        }
    } else {
        getMaxType();
    }
}
//安装类型检查
function installTypeCheck(data) {
    switch(data.installType) {
        case "package":
            installByPackage(data);
            break;
        case "wgt":
            downloadWgt(data);
            break;
    }
}
//通过安装包方式安装
function installByPackage(data) {
    if(plus.os.name == "Android") {
        downloadApk(data.versionUrl);
    } else if(plus.os.name == "iOS") {
        plus.runtime.openURL(data.versionUrl);
    }
}
//通过应用资源方式安装
function downloadWgt(data) {
    plus.nativeUI.showWaiting("下载中......");
    plus.downloader.createDownload(data.versionUrl, {
        filename: "_doc/update/"
    }, function(d, status) {
        plus.nativeUI.closeWaiting();
        if(status == 200) {
            installWgt(d.filename); // 安装wgt包
        } else {
            mui.alert("下载失败，请检查网络后重新下载", "提示", "重新下载", function() {
                downloadWgt(data);
            });
        }
    }).start();
}

// 更新应用资源
function installWgt(path) {
    plus.nativeUI.showWaiting("安装更新中...");
    plus.runtime.install(path, {}, function() {
        plus.nativeUI.closeWaiting();
        plus.nativeUI.alert("安装更新成功", function() {
            plus.runtime.restart();
        });
    }, function(e) {
        plus.nativeUI.closeWaiting();
        plus.nativeUI.alert("安装更新失败[" + e.code + "]：" + e.message);
    });
}

//下载安装包
function downloadApk(url) {
    plus.nativeUI.showWaiting("下载中...");
    var dtask = plus.downloader.createDownload(url, {}, function(d, status) {
        if(status == 200) { // 下载成功
            var path = d.filename;
            plus.runtime.install(path, {}, function() {
                plus.nativeUI.closeWaiting();
                plus.nativeUI.alert("更新成功", function() {
                    plus.runtime.restart();
                });
            }, function(e) {
                plus.nativeUI.closeWaiting();
                mui.alert("安装更新失败，请重新下载", function() {
                    downloadApk(url);
                });
            });
        } else { //下载失败
            plus.nativeUI.closeWaiting();
            mui.alert("下载失败，请检查网络后重新下载", "提示", "重新下载", function() {
                downloadApk(url);
            });
        }
    });
    dtask.start();
}