var pageName, pageNum = 1,
    pullAct = "up";
mui.init({
    pullRefresh: {
        auto: true,
        container: '#pullrefresh',
        down: {
            callback: pulldownRefresh
        },
        up: {
            contentrefresh: '正在加载...',
            contentnomore: '只有这么多了',
            callback: pullupRefresh
        }
    }
});
/**
 * 下拉刷新具体业务实现
 */
function pulldownRefresh() {
    pageNum = 1;
    pullAct = "down";
    getList();
}
var count = 0;
/**
 * 上拉加载具体业务实现
 */
function pullupRefresh() {
    pullAct = "up";
    getList();
}
if(mui.os.plus) {
    mui.plusReady(function() {
        plus.nativeUI.showWaiting("", {
            padlock: true
        });
        getList();
    });
} else {
    mui.ready(function() {
        getList();
    });
}

function getList() {
    if(!pageName) {
        var thisWebView = plus.webview.currentWebview();
        switch(thisWebView.id) {
            case "appointment_of_master_sub.html":
                pageName = "appointment";
                break;
            case "evaluation_of_master_sub.html":
                pageName = "evaluation";
                break;
            case "favorite_of_master_sub.html":
                pageName = "favorite";
                break;
            default:
                mui.toast("获取信息失败，请返回重试");
                return;
        }
    }
    var userId = plus.storage.getItem("user_id");
    if(!userId) {
        plus.nativeUI.closeWaiting();
        mui.alert("获取用户登录信息失败，请重新登录", function() {});
        return;
    }
    var url = "userWorker/worker/listWorkerByTable?userId=" + userId + "&btype=" + pageName + "&pageNum=" + pageNum;
    AJAX.get(url, function(xhr) {
        plus.nativeUI.closeWaiting();
        if(xhr.status == 1) {
            showList(xhr);
        } else {
            mui.toast(xhr.msg ? xhr.msg : "获取师傅信息失败，请重试");
            getFail();
        }
    }, function(xhr) {
        plus.nativeUI.closeWaiting();
        mui.toast("网络连接失败，请重试");
        getFail();
    });
}

function getFail() {
    if(pullAct == "up") {
        mui('#pullrefresh').pullRefresh().endPullupToRefresh(true); //参数为true代表没有更多数据了。
        mui('#pullrefresh').pullRefresh().refresh(true);
    } else if(pullAct == "down") {
        mui('#pullrefresh').pullRefresh().endPulldownToRefresh(); //refresh completed
    }
}

function showList(data) {
    if(pullAct == "down") {
        document.getElementById("list").innerHTML = "";
    }
    var table = document.body.querySelector('#list');
    var arr = checkData(data.content);
    if(data.content.length == 0) {
        table.innerHTML = "<p class='mui-h4 mui-text-center' style='padding:70% 0;'>暂无好师傅</p>";
    }
    for(var i in arr) {
        var li = document.createElement('li');
        li.id = "worker-item-" + arr[i].id;
        li.className = 'mui-table-view-cell';
        if(arr[i].typeId == 6 || arr[i].typeId == 7) {
            li.innerHTML = buildPromoter(arr[i]);
        } else {
            li.innerHTML = '<div class="mui-slider-right">' +
                '    <a worker-id="' + arr[i].id + '" worker-name="' + arr[i].userName + '" class="mui-btn mui-btn-red del-worker" style="transform: translate(0px, 0px);">删除</a>' +
                '</div>' +
                '<div class="mui-slider-handle" style="transform: translate(0px, 0px);">' +
                '   <div id="worker-' + arr[i].id + '" worker-type="' + arr[i].typeId + '" worder-card="' + arr[i].switchCard + '" worder-masked="' + arr[i].masked + '" worder-userid="' + arr[i].id + '" class="mui-navigate-right">' +
                '       <div class="mui-row worker">' +
                '           <div class="mui-col-xs-2 ub-ver">' +
                '               <div><img src="' + arr[i].icon + '" alt="' + arr[i].userName + '" /></div>' +
                '            <span style="color:#f5c898;text-align:center;font-size:12px;line-height:1.2;">' + arr[i].userType + '</span>' +
                '               <span class="worker-status mui-h6 ' + arr[i].statusClass + '">' + arr[i].statusText + '</span>' +
                '           </div>' +
                '           <div class="mui-col-xs-10 ub-ver">' +
                '            <div class="ub-pj mui-h7">' +
                '                <div class="mui-col-xs-8">' +
                '                    <span class="mui-h5" style="color:#000;">' + arr[i].userName + '</span>' +
                '                    <i class="ms txc-o" style="' + arr[i].certificationStyle + '">&#xe61c;</i><span style="' + arr[i].certificationStyle + '">实名登记</span>' +
                '                </div>' +
                '                <div class="mui-col-xs-4 mui-text-left"><i class="ms txc-o">&#xe60b;</i>好评率:<span class="txc-o">' + arr[i].rate + '</span></div>' +
                '            </div>' +
                '               <div class="ub-pj mui-h7">' +
                '                <div class="mui-col-xs-8">师傅号：<span>' + arr[i].code + '</span></div>' +
                '                <div class="mui-col-xs-4 mui-text-left"><i class="ms txc-b">&#xe609;</i>浏览:<span class="txc-b">' + arr[i].workerPageviews + '</span></div>' +
                '               </div>' +
                '               <div class="mui-h7 worker-skill">' +
                '                   技能：' + arr[i].skillList + 
                '               </div>' +
                '               <div class="ub-pj mui-h7 worker-service">' +
                '                   <div>服务：' + arr[i].serviceList + '</div>' +
                '                   <div class="del-worker" worker-id="' + arr[i].id + '" worker-name="' + arr[i].userName + '">删除</div>' +
                '               </div>' +
                '           </div>' +
                '       </div>' +
                '   </div>' +
                '   <div class="mui-masked" style="' + arr[i].maskedStyle + '"></div>' +
                '   <div class="mui-closed" style="' + arr[i].switchCardStyle + '"></div>' +
                '</div>';
        }
        table.appendChild(li);
    }
    removeOpenEvent();
    removeDelEvent();
    addOpenEvent();
    addDelEvent();
    if(pullAct == "up") {
        mui('#pullrefresh').pullRefresh().endPullupToRefresh(!data.hasNextPage); //参数为true代表没有更多数据了。
    } else if(pullAct == "down") {
        mui('#pullrefresh').pullRefresh().endPulldownToRefresh(); //refresh completed
        mui('#pullrefresh').pullRefresh().refresh(true);
        mui('#pullrefresh').pullRefresh().enablePullupToRefresh();
    }
    if(data.hasNextPage) {
        pageNum = data.nextPage;
    } else {
        mui('#pullrefresh').pullRefresh().disablePullupToRefresh();
        mui('#pullrefresh').pullRefresh().endPullupToRefresh(true);
    }
}

function buildPromoter(data) {
    var html = '<div class="mui-slider-right">' +
        '    <a worker-id="' + data.id + '" worker-name="' + data.userName + '" class="mui-btn mui-btn-red del-worker" style="transform: translate(0px, 0px);">删除</a>' +
        '</div>' +
        '<div class="mui-slider-handle" style="transform: translate(0px, 0px);">' +
        '   <div id="worker-' + data.id + '" worker-type="' + data.typeId + '" worder-card="' + data.switchCard + '" worder-masked="' + data.masked + '" worder-userid="' + data.id + '" class="mui-navigate-right">' +
        '       <div class="mui-row worker">' +
        '           <div class="mui-col-xs-2 ub-ver">' +
        '               <div><img src="' + data.icon + '" alt="' + data.userName + '" /></div>' +
        '            <span style="color:#f5c898;text-align:center;font-size:12px;line-height:1.2;">' + data.userType + '</span>' +
        '               <span class="worker-status mui-h6 ' + data.statusClass + '">' + data.statusText + '</span>' +
        '           </div>' +
        '           <div class="mui-col-xs-10 ub-ver">' +
        '            <div class="ub-pj mui-h7">' +
        '                <div class="mui-col-xs-8">' +
        '                    <span class="mui-h5" style="color:#000;">' + data.userName + '</span>' +
        '                </div>' +
        '            </div>' +
        '               <div class="ub-pj mui-h7">' +
        '                <div class="mui-col-xs-8">师傅号：<span>' + data.code + '</span></div>' +
        '               </div>' +
        '               <div class="mui-h7 worker-skill">&nbsp;</div>' +
        '               <div class="ub-pj mui-h7 worker-service">' +
        '                   <div><span>推广员</span></div>' +
        '                   <div class="del-worker" worker-id="' + data.id + '" worker-name="' + data.userName + '">删除</div>' +
        '               </div>' +
        '           </div>' +
        '       </div>' +
        '   </div>' +
        '   <div class="mui-masked" style="' + data.maskedStyle + '"></div>' +
        '   <div class="mui-closed" style="' + data.switchCardStyle + '"></div>' +
        '</div>';
    return html;
}
//师傅列表数据检查重组
function checkData(data) {
    var screenWidth = plus.screen.resolutionWidth * plus.screen.scale;
    for(var i in data) {
        data[i].userName = data[i].userName ? data[i].userName : "";
        //人气
        if(!data[i].popuVal) {
            data[i].popuVal = 0;
        }
        //师傅类型 5:VIP
        if(data[i].typeId == 5) {
            data[i]["userType"] = "VIP";
        } else {
            data[i]["userType"] = "注册";
        }

        //工作状态
        if(data[i].switchWorkStatus == 1) {
            data[i]["statusClass"] = "active";
            data[i]["statusText"] = "工作";
        } else {
            data[i]["statusClass"] = "";
            data[i]["statusText"] = "休息";
        }

        //身份认证
        if(data[i].certification == 1) {
            data[i]["certificationStyle"] = "";
            data[i]["maskedStyle"] = "display:none;";
            data[i]["masked"] = "0"; //控制是否打开已屏蔽界面
        } else {
            data[i]["certificationStyle"] = "display:none;";
            if(data[i].leaveday < 0) {
                data[i]["maskedStyle"] = "";
                data[i]["masked"] = "1";
            } else {
                data[i]["maskedStyle"] = "display:none;";
                data[i]["masked"] = "0";
            }
        }

        //电子名片开关状态
        if(data[i].switchCard == 1) {
            data[i]["switchCardStyle"] = "display:none;";
        } else {
            if(data[i]["maskedStyle"] == "") {
                data[i]["switchCardStyle"] = "display:none;";
            } else {
                data[i]["switchCardStyle"] = "";
            }
        }
        //技能
        data[i]["skillList"] = "";
        if(data[i].skill1Name) {
            data[i]["skillList"] += "<span>" + data[i].skill1Name + "</span>"
        }
        if(data[i].skill2Name) {
            data[i]["skillList"] += "<span>" + data[i].skill2Name + "</span>"
        }
        //服务
        data[i]["serviceList"] = "";
        if(data[i].service1Name) {
            data[i]["serviceList"] += "<span>" + data[i].service1Name + "</span>"
        }

        var serviceThree = data[i].service1Name + data[i].service2Name + data[i].service3Name;
        var serviceTwo = data[i].service1Name + data[i].service2Name;
        if(serviceTwo.length < (screenWidth / 50)) {
            if(data[i].service2Name) {
                data[i]["serviceList"] += "<span>" + data[i].service2Name + "</span>"
            }
        }
        if(serviceThree.length < (screenWidth / 50)) {
            if(data[i].service3Name) {
                data[i]["serviceList"] += "<span>" + data[i].service3Name + "</span>"
            }
        }
    }
    return data;
}
//绑定item点击事件
function addOpenEvent() {
    mui("#list").on('tap', ".mui-navigate-right", function() {
        var url = "worker_detail.html";
        var cardStatus = this.getAttribute("worder-card");
        var maskedStatus = this.getAttribute("worder-masked");
        if(maskedStatus == "1") {
            url = "card_masked.html";
        } else if(cardStatus == "0") {
            url = "card_closed.html";
        }
        var typeId = this.getAttribute("worker-type");
        if(typeId == 6 || typeId == 7) {
            mui.openWindow({
                url: "o2o_card_suggest.html",
                extras: {
                    userId: this.getAttribute("worder-userid")
                }
            });
        } else {
            mui.openWindow({
                url: '../tab_skill/' + url,
                id: url,
                extras: {
                    userId: this.getAttribute("worder-userid")
                }
            });
        }
    });
}

function removeOpenEvent() {
    mui("#list").off('tap', ".mui-navigate-right");
}

function addDelEvent() {
    mui("#list").on("tap", ".del-worker", function(e) {
        var userId = this.getAttribute("worker-id");
        var userName = this.getAttribute("worker-name");
        e.stopPropagation();
        mui.confirm("确定删除" + userName + "？", "提示", ["取消", "确定"], function(e) {
            if(e.index) {
                delUser(userId);
            }
        })
    });
}

function removeDelEvent() {
    mui("#list").off("tap", ".del-worker");
}

//提交删除请求
function delUser(workerId) {
    var userId = plus.storage.getItem("user_id");
    if(!userId) {
        plus.nativeUI.closeWaiting();
        mui.alert("获取用户登录信息失败，请重新登录", function() {});
        return;
    }
    plus.nativeUI.showWaiting("", {
        padlock: true
    });
    var url = "userWorker/worker/deleteWorkerByTable?userId=" + userId + "&workerId=" + workerId + "&btype=" + pageName;
    AJAX.get(url, function(xhr) {
        plus.nativeUI.closeWaiting();
        if(xhr.status == 1) {
            removeElement(document.getElementById("worker-item-" + workerId));
            mui.toast("删除成功");
        } else {
            mui.toast(xhr.msg ? xhr.msg : "删除失败，请稍后重试");
        }
    }, function(xhr) {
        plus.nativeUI.closeWaiting();
        mui.toast("网络连接失败，请稍后重试");
    }, "DELETE");
}

//删除节点
function removeElement(_element) {
    if(_element) {
        var _parentElement = _element.parentNode;
        if(_parentElement) {
            _parentElement.removeChild(_element);
        }
    }
}