/*!
 * ======================================================
 * FeedBack Template For MUI (http://dev.dcloud.net.cn/mui)
 * =======================================================
 * @version:1.0.0
 * @author:cuihongbao@dcloud.io
 */
var feedback = {
    imageList: document.getElementById('image-list'),
};
(function() {
    feedback.index = 1;
    var size = null;
    var imageIndexIdNum = 0;
    var starIndex = 0;
    feedback.files = [];
    feedback.getFileInputArray = function() {
        return [].slice.call(feedback.imageList.querySelectorAll('.file'));
    };
    feedback.addFile = function(path) {
        feedback.files.push({
            name: "images" + feedback.index,
            path: path
        });
        feedback.index++;
    };
    feedback.detailFile = function(name) {
        for (var i in feedback.files) {
            if (feedback.files[i].name == name) {
                feedback.files.splice(i, 1);
            }
        }
    };
    /**
     * 初始化图片域占位
     */
    feedback.newPlaceholder = function() {
        var fileInputArray = feedback.getFileInputArray();
        if (fileInputArray &&
            fileInputArray.length > 0 &&
            fileInputArray[fileInputArray.length - 1].parentNode.classList.contains('space')) {
            return;
        };
        imageIndexIdNum++;
        var placeholder = document.createElement('div');
        placeholder.setAttribute('class', 'image-item space');
        //删除图片
        var closeButton = document.createElement('div');
        closeButton.setAttribute('class', 'image-close');
        closeButton.setAttribute('filename', "images" + feedback.index);
        closeButton.innerHTML = 'X';
        //小X的点击事件
        closeButton.addEventListener('tap', function(event) {
            feedback.detailFile(this.getAttribute("filename"));
            feedback.imageList.removeChild(placeholder);
            return false;
        }, false);

        //
        var fileInput = document.createElement('div');
        fileInput.setAttribute('class', 'file');
        fileInput.setAttribute('id', 'image-' + imageIndexIdNum);
        fileInput.addEventListener('tap', function(event) {
            var self = this;
            var index = (this.id).substr(-1);
            plus.gallery.pick(function(e) {
                var name = e.substr(e.lastIndexOf('/') + 1);

                plus.zip.compressImage({
                    src: e,
                    dst: '_doc/' + name,
                    overwrite: true,
                    quality: 50
                }, function(zip) {
                    size += zip.size
                    if (size > (10 * 1024 * 1024)) {
                        return mui.toast('文件超大,请重新选择~');
                    }
                    if (!self.parentNode.classList.contains('space')) { //已有图片
                        feedback.files.splice(index - 1, 1, {
                            name: "images" + index,
                            path: e
                        });
                    } else { //加号
                        placeholder.classList.remove('space');
                        feedback.addFile(zip.target);
                        feedback.newPlaceholder();
                    }
                    placeholder.style.backgroundImage = 'url(' + zip.target + ')';
                }, function(zipe) {
                    mui.toast('压缩失败！')
                });

            }, function(e) {
            }, {});
        }, false);
        placeholder.appendChild(closeButton);
        placeholder.appendChild(fileInput);
        feedback.imageList.appendChild(placeholder);
    };
    /**
     * 填充初始化图片域占位
     */
    feedback.fillPlaceholder = function(src) {
        imageIndexIdNum++;
        var placeholder = document.createElement('div');
        placeholder.setAttribute('class', 'image-item space');
        placeholder.style.backgroundImage = 'url(' + src + ')';
        //删除图片
        var closeButton = document.createElement('div');
        closeButton.setAttribute('class', 'image-close');
        closeButton.setAttribute('filename', "images" + feedback.index);
        closeButton.innerHTML = 'X';
        //小X的点击事件
        closeButton.addEventListener('tap', function(event) {
            feedback.detailFile(this.getAttribute("filename"));
            feedback.imageList.removeChild(placeholder);
            return false;
        }, false);

        //
        var fileInput = document.createElement('div');
        fileInput.setAttribute('class', 'file');
        fileInput.setAttribute('id', 'image-' + imageIndexIdNum);
        fileInput.addEventListener('tap', function(event) {
            var self = this;
            var index = (this.id).substr(-1);
            plus.gallery.pick(function(e) {
                var name = e.substr(e.lastIndexOf('/') + 1);

                plus.zip.compressImage({
                    src: e,
                    dst: '_doc/' + name,
                    overwrite: true,
                    quality: 50
                }, function(zip) {
                    size += zip.size
                    if (size > (10 * 1024 * 1024)) {
                        return mui.toast('文件超大,请重新选择~');
                    }
                    if (!self.parentNode.classList.contains('space')) { //已有图片
                        feedback.files.splice(index - 1, 1, {
                            name: "images" + index,
                            path: e
                        });
                    } else { //加号
                        placeholder.classList.remove('space');
                        feedback.addFile(zip.target);
                        feedback.newPlaceholder();
                    }
                    placeholder.style.backgroundImage = 'url(' + zip.target + ')';
                }, function(zipe) {
                    mui.toast('压缩失败！')
                });

            }, function(e) {
            }, {});
        }, false);
        placeholder.classList.remove('space');
        placeholder.appendChild(closeButton);
        placeholder.appendChild(fileInput);
        feedback.imageList.appendChild(placeholder);
    };
    feedback.newPlaceholder();
})();